<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>conqueue: src/conqueue.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">conqueue
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">conqueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef CONQUEUE_H</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define CONQUEUE_H</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacemutils.html">mutils</a> {</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html">   14</a></span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classmutils_1_1conqueue.html">conqueue</a></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;  <span class="keyword">public</span>:</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;  <a class="code" href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">~conqueue</a>();</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">enqueue</a>(T&amp;&amp; el);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  T <a class="code" href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">dequeue</a>();</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  T <a class="code" href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">dequeueOrBlock</a>();</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  T <a class="code" href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">dequeueOrBlockFor</a>(std::chrono::system_clock::duration);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="keyword">private</span>:</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  std::mutex _mx;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  std::condition_variable _cv;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  std::vector&lt;T&gt; _container;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;};</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classmutils_1_1conqueue_html_a389275c51e7eb3f367c2ee8ac70a2615"><div class="ttname"><a href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">mutils::conqueue::dequeueOrBlock</a></div><div class="ttdeci">T dequeueOrBlock()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:23</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html"><div class="ttname"><a href="classmutils_1_1conqueue.html">mutils::conqueue</a></div><div class="ttdef"><b>Definition:</b> conqueue.h:14</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_a8f0b24fc2bf5a4e84db449a9c4fc65b2"><div class="ttname"><a href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">mutils::conqueue::~conqueue</a></div><div class="ttdeci">~conqueue()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:3</div></div>
<div class="ttc" id="namespacemutils_html"><div class="ttname"><a href="namespacemutils.html">mutils</a></div><div class="ttdef"><b>Definition:</b> conqueue.h:8</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_a1f77547ec1b71152b6b5657259b704fc"><div class="ttname"><a href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">mutils::conqueue::dequeueOrBlockFor</a></div><div class="ttdeci">T dequeueOrBlockFor(std::chrono::system_clock::duration)</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:35</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_aebad37af104f9b7bafbd02325795ee81"><div class="ttname"><a href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">mutils::conqueue::enqueue</a></div><div class="ttdeci">void enqueue(T &amp;&amp;el)</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:5</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_ae5e6b297131a997b8e6a37b1ae9b6f52"><div class="ttname"><a href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">mutils::conqueue::dequeue</a></div><div class="ttdeci">T dequeue()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:12</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
